// ----------------------------------------------------------------------------	-

// ============================================================================	=

/* update 09-03-2013 */

/* Program written by Klaus R. Schambeck */
/* Copyright (C) 2013 - 2015 efiLabs.com */

// ============================================================================	=

#include "Console.h"

#include <QScrollBar>
#include <QMenu>

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	-
 */
#define cConEna 1
#if	cConEna
uint MsgEna = TConsole::eMsgEna ;
void MsgPrint (uint ena, const char *form, ...)
{
  if (MsgEna < ena) return ;

//  if (CritSec) CritSec->Enter() ;
  enum {  eBufSze = 0x0100 } ;
  char b [eBufSze] ;
  va_list  ap ;
  va_start (ap, form) ;
  vsnprintf (b, eBufSze, form, ap) ;
  va_end (ap) ;
  b [eBufSze-1] = '\0' ;
  if (Console) Console->Put (b) ;
//if (CritSec) CritSec->Leave () ;
}
#endif
// ----------------------------------------------------------------------------	-

const ulong TConsole::cRevNum = eRevConsole ;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	-
 */
TConsole *Console ;

TConsole::TConsole (const char *name, QWidget *parent) :
  QPlainTextEdit (parent), EchoF (eEcho)
{
  setWindowTitle (name) ;
  document ()->setMaximumBlockCount (eBlockCnt) ;
  QPalette p = palette () ;
  p.setColor (QPalette::Base, Qt::white) ;
  p.setColor (QPalette::Text, Qt::black) ;
  setPalette (p) ;

  QFont f ("unexistent") ;
  f.setStyleHint (QFont::Monospace) ;
  setFont (f) ;
}
/* ----------------------------------------------------------------------------	-
 */
void TConsole::Put (const QByteArray &data)
{
  insertPlainText (QString (data)) ;

  QScrollBar *bar = verticalScrollBar () ;
  bar->setValue (bar->maximum ()) ;
}
/* ----------------------------------------------------------------------------	-
 */
void TConsole::keyPressEvent (QKeyEvent *evt)
{
  switch (evt->key ()) {
  case Qt::Key_Back :
  case Qt::Key_Backspace :
  case Qt::Key_Left :
  case Qt::Key_Right :
  case Qt::Key_Up :
  case Qt::Key_Down :
    evt->ignore () ; return ;

  default :
    if (EchoF) QPlainTextEdit::keyPressEvent (evt) ;
    emit Get (evt->text().toLocal8Bit ()) ;
  }
}
/* ----------------------------------------------------------------------------	-
 * /
void TConsole::mousePressEvent (QMouseEvent *evt)
{
  Q_UNUSED (evt)
  setFocus() ;
} */
/* ----------------------------------------------------------------------------	-
 * /
void TConsole::mouseDoubleClickEvent (QMouseEvent *evt)
{
  Q_UNUSED (evt)
} */
/* ----------------------------------------------------------------------------	-
 */
void TConsole::contextMenuEvent (QContextMenuEvent *evt)
{
  QMenu   *ctx = createStandardContextMenu () ;
	   ctx->addSeparator () ;
  QAction *clr = ctx->addAction ("Clear") ;

  connect (clr, SIGNAL(triggered ()), this, SLOT(clear ())) ;

  ctx->exec (evt->globalPos ()) ;
}
// ----------------------------------------------------------------------------	-
